# A test for encryption (#27: https://forge.ipsl.jussieu.fr/epoll/ticket/27)

use Crypt::RSA; # crypt/decrypt
use Crypt::CBC; # sym key
use XML::Simple; # dump data
use MIME::Base64; # to make it ascii

print localtime() . "\n";
my $rsa = new Crypt::RSA ES => 'PKCS1v15'; 

    my ($public, $private) = 
        $rsa->keygen ( 
            Identity  => 'Vote ID 12',
            Size      => 768,  
            Password  => undef, 
            Verbosity => 0,
            KF=>'SSH',
        ) or die $rsa->errstr();
print $public->serialize;
print "\n";
print encode_base64($private->serialize);
print "\n";


print localtime() . "\n";
my $xs = XML::Simple->new(ForceArray => 1, RootName => 'ballot');

my @encballot;

foreach my $count (0 .. 100) {
my $xml = $xs->XMLout({ id => "8daad55a7f94a4fb79bda7ab007$count", sbal => [ 'coco', 'kiki', $count ], fsbal => [ $count ] });

my $symkey = map{ chr(rand(256)) } (1 .. (256 / 8));
#print "# ENC SYMKEY\n";
my $encryptedsymkey = $rsa->encrypt ( 
            Message    => $symkey,
            Key        => $public,
            Armour     => 1,
        ) || die $rsa->errstr();

# reading
my $cipher = new Crypt::CBC($symkey, 'DES');
my $encryptedballot = $cipher->encrypt_hex($xml);

push(@encballot, { key => $encryptedsymkey, bal => $encryptedballot });
}

print "###################################\n";
print localtime() . "\n";

my $c = 0;
foreach (@encballot) {
my $encryptedsymkey = $_->{key};
my $encryptedballot = $_->{bal};
my $ballot;
print localtime() . "\n" if ($c ==1);
$c++;
#print "# DEC SYMKEY $c\n";
$symkey = $rsa->decrypt(
        Cyphertext => $encryptedsymkey,
            Key        => $private,
            Armour     => 1,
        ) || die $rsa->errstr();
my $cipher = new Crypt::CBC($symkey, 'DES');
#print "# ENC BALLOT\n";
#print $encryptedballot . "\n";

#print "# DEC BALLOT\n";
    $symkey = $rsa->decrypt(
        Cyphertext => $encryptedsymkey,
            Key        => $private,
            Armour     => 1,
        ) || die $rsa->errstr();
    my $cipher = new Crypt::CBC($symkey, 'DES');
    $ballot = $cipher->decrypt_hex($encryptedballot);

# print $ballot
}
print localtime() . "\n";
